---
title: Set an XHR breakpoint
slug: Tools/Debugger/Set_an_XHR_breakpoint
tags:
  - Debugger
  - Debugging
  - JavaScript
  - XHR Breakpoint
---
<p>{{ToolsSidebar}}</p>

<p>An XHR (XMLHttpRequest) breakpoint breaks code execution when an XHR request is dispatched so that you can examine the current state of the program. You can break on all requests or on those that include a specific URL. To turn on the feature:</p>

<ol>
 <li>Open the debugger</li>
 <li>Click on "Pause on any URL" which acts as a wild card, causing the code to pause on any call, or,</li>
 <li>Click the plus sign next to the XHR breakpoints header, enter the URL in which you are interested, and press <kbd>Enter</kbd>.</li>
</ol>

<div class="notecard note">
<p><strong>Note</strong>: If you enter a key word instead of a URL, code execution will pause on any call to a URL that contains that keyword.</p>
</div>

<p><img alt="" src="https://mdn.mozillademos.org/files/16421/XHR_breakpoint.png" style="border: 1px solid black; display: block; height: 299px; margin: 0px auto; width: 302px;"></p>

<p>When your code breaks on an XHR request, the righthand pane will have two additional sections:</p>

<dl>
 <dt><strong>Call stack</strong></dt>
 <dd>The list of functions that were executed in order ot get to the currently executing code. Click on an item in the call stack to jump to the associated line in the code display.</dd>
 <dt><strong>Scopes</strong></dt>
 <dd>A list of the values that are in scope in the function, method, or event handler where the break occurred.</dd>
</dl>

<p><img alt="" src="https://mdn.mozillademos.org/files/16422/XHR_break.png" style="border: 1px solid black; display: block; margin: 0 auto;"></p>

<h2 id="Inline_variable_preview">Inline variable preview</h2>

<p>New in Firefox 71, the <a href="/en-US/docs/Tools/Debugger/UI_Tour#Source_pane">source pane</a> now gives you an instant preview of the variables on each line of code you've stepped through. See <a href="/en-US/docs/Tools/Debugger/How_to/Set_a_breakpoint#Inline_variable_preview">Set a breakpoint &gt; Inline variable preview</a> for more information.</p>
